package fr.yunes.search;

import java.io.*;
import java.util.Arrays;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ChunkReader {
    private RandomAccessFile r;
    private Chunk c;
    private String w;
    public ChunkReader(String fn, Chunk c, String w) throws IOException {
        this.r = new RandomAccessFile(fn,"r");
        this.c = c;
        this.w = w;
    }

    public long compute(boolean debug) throws Exception {
        if (debug) System.out.println("+Chunk "+c);
        long count = 0;
        r.seek(c.getStart());
        String line;
    	String patternString = "\\b"+w+"\\b";
    	Pattern pattern = Pattern.compile(patternString);
        while ( (line=r.readLine())!= null && r.getFilePointer()<c.getStop()) {
        	Matcher matcher = pattern.matcher(line);
        	while (matcher.find()) {
        		count++;
        	}
        }
        this.r.close();
        if (debug) System.out.println("-Chunk "+c+" "+count);
        return count;
    }
}
